//*************************************************************
//  Variable Declarations
//*************************************************************
System.Gadget.settingsUI = "Settings.html";

var Theme = "1";
var Size = "Small";
var Buttons = "";
var ButtonsNum = 0;
var Page = 0;
var ButtonArray = new Array();
var LockButton = "Yes";
var LockPanel = "";
var AmbientSet = "";
var Timer = "";
var UpdateTimer = "";
var i = 0;
var x = 0;
var uiString = "";
var UpdateFlag = "Off";
var UpdateSet = "On";
var ConfirmSet = "On";
var shell = new ActiveXObject("WScript.Shell");
var oFSO = new ActiveXObject("Scripting.FileSystemObject");
var XMLDoc = new ActiveXObject("Microsoft.XMLDOM"); 
var xmlObj = "";

//*************************************************************
//  Refresh The UI (Buttons, Timeclock, Mini Buttons, Size)
//*************************************************************
function RefreshUI()
{	
	ButtonsSet = System.Gadget.Settings.read("ButtonsSet");
	if (ButtonsSet == "")
	{
		RetrieveData();
		CheckUpdates();
	}
	
	clearInterval(UpdateTimer);

	Theme = System.Gadget.Settings.read("Theme");
	if (Theme == "")
		Theme = "1";
	
	Size = System.Gadget.Settings.read("Size");
	if (Size == "")
		Size = "Small";
		
	Buttons = System.Gadget.Settings.read("Buttons");
	if (Buttons == "")		
		Buttons = "Shutdown|Restart|Lock|SwitchUser|TaskManager|StandBy|Run|LogOff|CPrompt";
		
	Page = System.Gadget.Settings.read("Page");
	if (Page == "")
		Page = 0;
		
	LockButton = System.Gadget.Settings.read("LockButton");
	if (LockButton == "")
		LockButton = "Show";
		
	LockPanel = System.Gadget.Settings.read("LockPanel");
	if (LockPanel == "")
		LockPanel = "No";
		
	UpdateSet = System.Gadget.Settings.read("UpdateSet");
	if (UpdateSet == "")
		UpdateSet = "On";
	
	UpdateFlag = System.Gadget.Settings.read("UpdateFlag");
	if (UpdateFlag == "")
		UpdateFlag = "Off";
	
	//*************************************************************
	//  Variable Interface Styles (Backgrounds, Sizes)
	//*************************************************************	
	if (Size == "Large")
	{
		System.Gadget.document.body.style.height = "100px";
		System.Gadget.document.body.style.background = "url('Images/Themes/BG" + Theme + "Large.png') no-repeat";
	}
	
	if (Size == "Small")
	{
		System.Gadget.document.body.style.height = "60px";
		System.Gadget.document.body.style.background = "url('Images/Themes/BG" + Theme + "Small.png') no-repeat";
	}
	
	//*************************************************************
	//  UI Construction
	//*************************************************************	
	uiString = '<div id="ButtonSet" class="Set' + Size + '">';

	ButtonGen();
	
	uiString += '</div>';
	
	if (Size == "Small" && Page == 0 && ButtonsNum > 4)
		uiString += '<div id="RightArrowSmall" onclick="NextPage();" onmouseover="ButtonText(\'Next\');" onmouseout="ButtonText(\'\');"></div>';
		
	if (Size == "Small" && Page == 1)
	{
		uiString += '<div id="LeftArrowSmall" onclick="PrevPage();" onmouseover="ButtonText(\'Previous\');" onmouseout="ButtonText(\'\');"></div>';
	}
	
	if (Size == "Small" && Page == 1 && ButtonsNum > 7)
	{
		uiString += '<div id="RightArrowSmall" onclick="NextPage();" onmouseover="ButtonText(\'Next\');" onmouseout="ButtonText(\'\');"></div>';
	}
		
	if (Size == "Small" && Page == 2)
		uiString += '<div id="LeftArrowSmall" onclick="PrevPage();" onmouseover="ButtonText(\'Previous\');" onmouseout="ButtonText(\'\');"></div>';
	
	uiString += '<div id="BottomText" class="Bottom' + Size + '"></div>';
	uiString += '<div id="BottomConfirm' + Theme + '" class="BottomC' + Size + '" style="display:none;"></div>';
	
	if (LockButton == "Show")
		uiString += '<div id="LockButton" class="LockButton' + Size + '" onclick="LockToggle()" onmouseover="ButtonText(\'Lock Gadget\');" onmouseout="ButtonText(\'\');"></div>';
		
	uiString += '<div id="ChangeButton" onclick="ButtonText(\'\');"></div>';
	
	if (UpdateFlag == "On" && UpdateSet == "On")
		uiString += '<div id="UpdateButton" class="UpdateButton' + Size + '" onclick="ToggleUpdateFlyout();" onmouseover="ButtonText(\'New Update!\');" onmouseout="ButtonText(\'\');"></div>';
	
	System.Gadget.document.getElementById("GadgetContent").innerHTML = uiString;
	
	AmbientPrep();
	
	System.Gadget.document.getElementById("Changebutton").click();
	
	if (UpdateSet == "On")
		UpdateTimer = setInterval('CheckUpdates()', 720000);
}

//*************************************************************
//  Button Creation
//*************************************************************
function ButtonGen()
{
	Buttons = System.Gadget.Settings.read("Buttons");
	if (Buttons == "")		
		Buttons = "Shutdown|Restart|Lock|SwitchUser|TaskManager|StandBy|Run|LogOff|CPrompt";
		
	ConfirmSet = System.Gadget.Settings.read("ConfirmSet");
	if (ConfirmSet == "")
		ConfirmSet = "On";
	
	ButtonArray = Buttons.split("|");
	i = 0;
	ButtonsNum = 0;
	ButtonsNum = ButtonArray.length;
	
	Size = System.Gadget.Settings.read("Size");
	if (Size == "")
		Size = "Small";
	
	if (Size == "Large")
	{
		i = 0;
		x = 9;
		Page = 0;
	}
	else
	{
		if (Page == 0)
			x = 3;
		if (Page == 1)
			x = 6;
		if (Page == 2)
			x = 9;
			
		i = Page * 3;
	}	
	
	while (i < x)
	{
		if (ButtonArray[i] == "Shutdown" && LockPanel == "No" && ConfirmSet == "On")
			uiString += '<div id="FShutdown" class="FButton" onclick="Confirm(\'Shutdown\');" onmouseover="ButtonText(\'Shutdown\');" onmouseout="ButtonText(\'\');"></div>';

		if (ButtonArray[i] == "Shutdown" && LockPanel == "No" && ConfirmSet == "Off")
			uiString += '<div id="FShutdown" class="FButton" onclick="Exec(\'Shutdown\');" onmouseover="ButtonText(\'Shutdown\');" onmouseout="ButtonText(\'\');"></div>';
			
		if (ButtonArray[i] == "Shutdown" && LockPanel == "Yes")
			uiString += '<div id="FShutdownMute" class="FButtonMute"></div>';
			
		if (ButtonArray[i] == "Restart" && LockPanel == "No" && ConfirmSet == "On")
			uiString += '<div id="FRestart" class="FButton" onclick="Confirm(\'Restart\');" onmouseover="ButtonText(\'Restart\');" onmouseout="ButtonText(\'\');"></div>';
			
		if (ButtonArray[i] == "Restart" && LockPanel == "No" && ConfirmSet == "Off")
			uiString += '<div id="FRestart" class="FButton" onclick="Exec(\'Restart\');" onmouseover="ButtonText(\'Restart\');" onmouseout="ButtonText(\'\');"></div>';
			
		if (ButtonArray[i] == "Restart" && LockPanel == "Yes")
			uiString += '<div id="FRestartMute" class="FButtonMute"></div>';
			
		if (ButtonArray[i] == "Lock" && LockPanel == "No")
			uiString += '<div id="FLock" class="FButton" onclick="Exec(\'Lock\');" onmouseover="ButtonText(\'Lock\');" onmouseout="ButtonText(\'\');"></div>';
			
		if (ButtonArray[i] == "Lock" && LockPanel == "Yes")
			uiString += '<div id="FLockMute" class="FButtonMute"></div>';
			
		if (ButtonArray[i] == "SwitchUser" && LockPanel == "No")
			uiString += '<div id="FSwitchUser" class="FButton" onclick="Exec(\'SwitchUser\');" onmouseover="ButtonText(\'Switch User\');" onmouseout="ButtonText(\'\');"></div>';

		if (ButtonArray[i] == "SwitchUser" && LockPanel == "Yes")
			uiString += '<div id="FSwitchUserMute" class="FButtonMute"></div>';
			
		if (ButtonArray[i] == "TaskManager" && LockPanel == "No")
			uiString += '<div id="FTaskManager" class="FButton" onclick="Exec(\'TaskManager\');" onmouseover="ButtonText(\'Task Manager\');" onmouseout="ButtonText(\'\');"></div>';
			
		if (ButtonArray[i] == "TaskManager" && LockPanel == "Yes")
			uiString += '<div id="FTaskManagerMute" class="FButtonMute"></div>';
			
		if (ButtonArray[i] == "StandBy" && LockPanel == "No" && ConfirmSet == "On")
			uiString += '<div id="FStandBy" class="FButton" onclick="Confirm(\'StandBy\');" onmouseover="ButtonText(\'Sleep / Hibr.\');" onmouseout="ButtonText(\'\');"></div>';
			
		if (ButtonArray[i] == "StandBy" && LockPanel == "No" && ConfirmSet == "Off")
			uiString += '<div id="FStandBy" class="FButton" onclick="Exec(\'StandBy\');" onmouseover="ButtonText(\'Sleep / Hibr.\');" onmouseout="ButtonText(\'\');"></div>';
			
		if (ButtonArray[i] == "StandBy" && LockPanel == "Yes")
			uiString += '<div id="FStandByMute" class="FButtonMute"></div>';
			
		if (ButtonArray[i] == "LogOff" && LockPanel == "No" && ConfirmSet == "On")
			uiString += '<div id="FLogOff" class="FButton" onclick="Confirm(\'LogOff\');" onmouseover="ButtonText(\'Log Off\');" onmouseout="ButtonText(\'\');"></div>';
			
		if (ButtonArray[i] == "LogOff" && LockPanel == "No" && ConfirmSet == "Off")
			uiString += '<div id="FLogOff" class="FButton" onclick="Exec(\'LogOff\');" onmouseover="ButtonText(\'Log Off\');" onmouseout="ButtonText(\'\');"></div>';
			
		if (ButtonArray[i] == "LogOff" && LockPanel == "Yes")
			uiString += '<div id="FLogOffMute" class="FButtonMute"></div>';
			
		if (ButtonArray[i] == "CPrompt" && LockPanel == "No")
			uiString += '<div id="FCPrompt" class="FButton" onclick="Exec(\'CPrompt\');" onmouseover="ButtonText(\'C-Prompt\');" onmouseout="ButtonText(\'\');"></div>';

		if (ButtonArray[i] == "CPrompt" && LockPanel == "Yes")
			uiString += '<div id="FCPromptMute" class="FButtonMute"></div>';
			
		if (ButtonArray[i] == "Run" && LockPanel == "No")
			uiString += '<div id="FRun" class="FButton" onclick="Exec(\'Run\');" onmouseover="ButtonText(\'Run\');" onmouseout="ButtonText(\'\');"></div>';
			
		if (ButtonArray[i] == "Run" && LockPanel == "Yes")
			uiString += '<div id="FRunMute" class="FButtonMute"></div>';
			
		i++;
	}
}

//*************************************************************
//  Button MouseOver Text
//*************************************************************
function ButtonText(Text)
{
	clearInterval(Timer);
	document.getElementById("BottomText").innerHTML = "<small>" + Text + "</small>";
	if (Text == "")
		AmbientPrep();
}

//*************************************************************
//  Next Page
//*************************************************************
function NextPage()
{
	Page++;
	System.Gadget.Settings.write("Page", Page);
	RefreshUI();
	SaveData();
}

//*************************************************************
//  Previous Page
//*************************************************************
function PrevPage()
{
	Page--;
	System.Gadget.Settings.write("Page", Page);
	RefreshUI();
	SaveData();
}

//*************************************************************
//  Lock Panel Toggle
//*************************************************************
function LockToggle()
{	
	if (LockPanel == "No")
		LockPanel = "Yes";
	else
		LockPanel = "No";
	System.Gadget.Settings.write("LockPanel", LockPanel);
	uiString = "";
	ButtonGen();
	document.getElementById("ButtonSet").innerHTML = uiString;
	SaveData();
}

//*************************************************************
//  Ambient Text Prep
//*************************************************************
function AmbientPrep()
{	
	AmbientSet = System.Gadget.Settings.read("AmbientSet");
	if (AmbientSet == "")
		AmbientSet = "TimeDefault";
	clearInterval(Timer);
	
	if (AmbientSet == "TimeDefault")
	{
		DateTimePrep('TimeDefault');
		Timer = setInterval('DateTimePrep(\'TimeDefault\')', 1000);
	}
	if (AmbientSet == "TimeNoSec")
	{
		DateTimePrep('TimeNoSec');
		Timer = setInterval('DateTimePrep(\'TimeNoSec\')', 1000);
	}
	if (AmbientSet == "TimeMilitary")
	{
		DateTimePrep('TimeMilitary');
		Timer = setInterval('DateTimePrep(\'TimeMilitary\')', 1000);
	}
	if (AmbientSet == "TimeDate")
	{
		DateTimePrep('TimeDate');
		Timer = setInterval('DateTimePrep(\'TimeDate\')', 1000);
	}
	
	if (AmbientSet == "CPURes")
	{
		SysResourcePrep('CPURes');
		Timer = setInterval('SysResourcePrep(\'CPURes\')', 1000);
	}
	if (AmbientSet == "MemRes")
	{
		SysResourcePrep('MemRes');
		Timer = setInterval('SysResourcePrep(\'MemRes\')', 1000);
	}
}

//*************************************************************
//  Date / Time Prep
//*************************************************************
function DateTimePrep(Format)
{
	var date = new Date();
	var Minutes = date.getMinutes();
	var Seconds = date.getSeconds();
	var TimeString = "";
	
	Minutes = Minutes + "";
	if (Minutes.length == 1)
		Minutes = "0" + Minutes;
		
	Seconds = Seconds + "";
	if (Seconds.length == 1)
		Seconds = "0" + Seconds;
	
	var Hours = date.getHours();
	var MilHours = Hours;
	var amPM = "AM";
	if (Hours > 11) 
		amPM = "PM";
	if (Hours > 12)
		Hours = Hours - 12;
	if (Hours == 0) 
		Hours = 12;
		
	var Day = date.getDate();
	var Month = date.getMonth() + 1;
	var Year = date.getYear();
	
	var DateArray = new Array();
	var DateStr = date.toString();
	DateArray = DateStr.split(" ");
	
	if (Format == "TimeDate")
		TimeString += "<small>" + DateArray[1] + " " + Day + " " + Year + "</small>";
	
	if (Format == "TimeDefault")
		TimeString += "<small>" + Hours + ":" + Minutes + ":" + Seconds + " " + amPM + "</small>";
		
	if (Format == "TimeNoSec")
		TimeString += "<small>" + Hours + ":" + Minutes + " " + amPM + "</small>";
		
	if (Format == "TimeMilitary")
		TimeString += "<small>" + MilHours + ":" + Minutes + ":" + Seconds + "</small>";
	
	document.getElementById("BottomText").innerHTML = TimeString;
}

//*************************************************************
//  System Resource Prep
//*************************************************************
function SysResourcePrep(Res)
{
	var ResString = "";
	
	if (Res == "CPURes")
	{
		var CPUStream = 0;
		var CPUList = System.Machine.CPUs;
		var CPUNum = CPUList.count;
		
		for (i = 0; i < CPUNum; i++)
		{
			CPUStream = CPUStream + CPUList.item(i).usagePercentage;
		}
		
		CPUStream = Math.round((CPUStream / CPUNum)*10)/10;
		CPUTest = Math.round(CPUStream / CPUNum);
		
		if (CPUTest == 100)
			ResString = "<small>CPU: " + CPUTest + "%</small>";
		else
		{
			if (String(CPUStream).indexOf('.') == -1)
				ResString = "<small>CPU: " + CPUStream + ".0%</small>";
			else
				ResString = "<small>CPU: " + CPUStream + "%</small>";
		}
	}
	
	if (Res == "MemRes")
	{
		var MemTotal = System.Machine.totalMemory;
		var MemAvail = System.Machine.availableMemory;
		var MemUsed = MemTotal - MemAvail;
		
		var MemUse = Math.round((MemUsed / MemTotal) * 100 * 100)/100;
		var MemTest = Math.round((MemUsed / MemTotal) * 100);
		
		if (MemTest == 100)
			ResString = "<small>RAM: " + MemTest + "%</small>";
		else
		{
			if (String(MemUse).indexOf('.') == -1)
				ResString = "<small>RAM: " + MemUse + ".00%</small>";
			else
				ResString = "<small>RAM: " + MemUse + "%</small>";
		}
	}
	
	document.getElementById("BottomText").innerHTML = ResString;
}

//*************************************************************
//  Shutdown Execute
//*************************************************************
function Exec(Order)
{
	System.Gadget.document.getElementById("BottomConfirm" + Theme).style.display = "none";
	
	if (Order == "Shutdown")
		System.Shell.execute('shutdown', '-p');
	if (Order == "Restart")
		System.Shell.execute('shutdown', '-r -f -t 01');
	if (Order == "Lock")
		System.Shell.execute('rundll32.exe', 'user32.dll,LockWorkStation');
	if (Order == "SwitchUser")
		System.Shell.execute('rundll32.exe', 'user32.dll,LockWorkStation');
	if (Order == "TaskManager")
		System.Shell.execute('taskmgr');
	if (Order == "StandBy")
		System.Shell.execute('rundll32.exe', 'powrprof.dll,SetSuspendState');
	if (Order == "Run")
		System.Shell.execute(System.Gadget.path + "/JS/Run.lnk");
	if (Order == "LogOff")
		System.Shell.execute('shutdown', '-l');
	if (Order == "CPrompt")
		System.Shell.execute('cmd');
}

//*************************************************************
//  Confirm
//*************************************************************
function Confirm(Order)
{
	Theme = System.Gadget.Settings.read("Theme");
	if (Theme == "")
		Theme = "1";
	
	if (Order == "Shutdown")
	{
		System.Gadget.document.getElementById("BottomConfirm" + Theme).style.display = "block";
		document.getElementById("BottomConfirm" + Theme).innerHTML = "<small class='CText'>Confirm:  <a href='javascript:Exec(\"Shutdown\");'>Yes</a> / <a href='javascript:Decline();'>No</a></small>";
	}
	
	if (Order == "Restart")
	{
		System.Gadget.document.getElementById("BottomConfirm" + Theme).style.display = "block";
		document.getElementById("BottomConfirm" + Theme).innerHTML = "<small class='CText'>Confirm:  <a href='javascript:Exec(\"Restart\");'>Yes</a> / <a href='javascript:Decline();'>No</a></small>";
	}
	
	if (Order == "StandBy")
	{
		System.Gadget.document.getElementById("BottomConfirm" + Theme).style.display = "block";
		document.getElementById("BottomConfirm" + Theme).innerHTML = "<small class='CText'>Confirm:  <a href='javascript:Exec(\"StandBy\");'>Yes</a> / <a href='javascript:Decline();'>No</a></small>";
	}
	
	if (Order == "LogOff")
	{
		System.Gadget.document.getElementById("BottomConfirm" + Theme).style.display = "block";
		document.getElementById("BottomConfirm" + Theme).innerHTML = "<small class='CText'>Confirm:  <a href='javascript:Exec(\"LogOff\");'>Yes</a> / <a href='javascript:Decline();'>No</a></small>";
	}
}

function Decline()
{
	System.Gadget.document.getElementById("BottomConfirm" + Theme).style.display = "none";
}

//*************************************************************
//  Save Data
//*************************************************************
function SaveData()
{
	Theme = System.Gadget.Settings.read("Theme");
	if (Theme == "")
		Theme = "1";
	
	Size = System.Gadget.Settings.read("Size");
	if (Size == "")
		Size = "Small";
		
	Buttons = System.Gadget.Settings.read("Buttons");
	if (Buttons == "")		
		Buttons = "Shutdown|Restart|Lock|SwitchUser|TaskManager|StandBy|Run|LogOff|CPrompt";
		
	ButtonsSet = System.Gadget.Settings.read("ButtonsSet");
	if (ButtonsSet == "")		
		ButtonsSet = "Shutdown|Restart|Lock|SwitchUser|TaskManager|StandBy|Run|LogOff|CPrompt";
		
	Page = System.Gadget.Settings.read("Page");
	if (Page == "")
		Page = 0;
		
	LockButton = System.Gadget.Settings.read("LockButton");
	if (LockButton == "")
		LockButton = "Show";
		
	LockPanel = System.Gadget.Settings.read("LockPanel");
	if (LockPanel == "")
		LockPanel = "No";
		
	AmbientSet = System.Gadget.Settings.read("AmbientSet");
	if (AmbientSet == "")
		AmbientSet = "TimeDefault";
		
	UpdateSet = System.Gadget.Settings.read("UpdateSet");
	if (UpdateSet == "")
		UpdateSet = "On";
	
	UpdateFlag = System.Gadget.Settings.read("UpdateFlag");
	if (UpdateFlag == "")
		UpdateFlag = "Off";
		
	ConfirmSet = System.Gadget.Settings.read("ConfirmSet");
	if (ConfirmSet == "")
		ConfirmSet = "On";
	
	try{
		var sPath = System.Gadget.path;
		var sPos = System.Gadget.path.lastIndexOf("\\");
		var sFilename = sPath.substr(0,sPos) + "\\SysControlData.xml";
		var xString = "";
		if (oFSO.FileExists(sFilename))
		{
			oFSO.DeleteFile(sFilename, true);
		}
		var oFile = oFSO.CreateTextFile(sFilename, true);
		
		xString += '<?xml version="1.0" ?>';
		xString += '<Settings>';
		xString += '<Theme>' + Theme + '</Theme>';
		xString += '<Size>' + Size + '</Size>';
		xString += '<Buttons>' + Buttons + '</Buttons>';
		xString += '<ButtonsSet>' + ButtonsSet + '</ButtonsSet>';
		xString += '<Page>' + Page + '</Page>';
		xString += '<LockButton>' + LockButton + '</LockButton>';
		xString += '<LockPanel>' + LockPanel + '</LockPanel>';
		xString += '<AmbientSet>' + AmbientSet + '</AmbientSet>';
		xString += '<UpdateSet>' + UpdateSet + '</UpdateSet>';
		xString += '<UpdateFlag>' + UpdateFlag + '</UpdateFlag>';
		xString += '<ConfirmSet>' + ConfirmSet + '</ConfirmSet>';
		xString += '</Settings>';
		
		oFile.WriteLine(xString);
		oFile.Close();
	} 
	catch(err) {
		//System.Gadget.document.getElementById("GadgetContent").innerHTML= "<small>File I/O Error</small>";
	}
}

//*************************************************************
//  Retrieve Data
//*************************************************************
function RetrieveData()
{
	try{
		var sPath = System.Gadget.path;
		var sPos = System.Gadget.path.lastIndexOf("\\");
		var sFilename = sPath.substr(0,sPos) + "\\SysControlData.xml";
		if (oFSO.FileExists(sFilename))
		{			
			LoadXML(sFilename);
			var xFile = XMLDoc.getElementsByTagName("Settings")[0];
			
			Theme = xFile.getElementsByTagName("Theme")[0].text;
			Size = xFile.getElementsByTagName("Size")[0].text;
			Buttons = xFile.getElementsByTagName("Buttons")[0].text;
			ButtonsSet = xFile.getElementsByTagName("ButtonsSet")[0].text;
			Page = xFile.getElementsByTagName("Page")[0].text;
			LockButton = xFile.getElementsByTagName("LockButton")[0].text;
			LockPanel = xFile.getElementsByTagName("LockPanel")[0].text;
			AmbientSet = xFile.getElementsByTagName("AmbientSet")[0].text;
			UpdateSet = xFile.getElementsByTagName("UpdateSet")[0].text;
			UpdateFlag = xFile.getElementsByTagName("UpdateFlag")[0].text;
			ConfirmSet = xFile.getElementsByTagName("ConfirmSet")[0].text;
		}
		else
		{
			SaveData();
			RetrieveData();
		}
	} 
	catch(err) {
		//System.Gadget.document.getElementById("GadgetContent").innerHTML = "<small>File I/O Error</small>";
	}
	
	if (Theme == "")
		Theme = "1";
	
	if (Size == "")
		Size = "Small";
		
	if (Buttons == "")		
		Buttons = "Shutdown|Restart|Lock|SwitchUser|TaskManager|StandBy|Run|LogOff|CPrompt";
		
	if (ButtonsSet == "")		
		ButtonsSet = "Shutdown|Restart|Lock|SwitchUser|TaskManager|StandBy|Run|LogOff|CPrompt";
		
	if (Page == "")
		Page = 0;
		
	if (LockButton == "")
		LockButton = "Show";
		
	if (LockPanel == "")
		LockPanel = "No";
		
	if (AmbientSet == "")
		AmbientSet = "TimeDefault";
		
	if (UpdateSet == "")
		UpdateSet = "On";
	
	if (UpdateFlag == "")
		UpdateFlag = "Off";
		
	if (ConfirmSet == "")
		ConfirmSet = "On";
		
	System.Gadget.Settings.write("Theme", Theme);
	System.Gadget.Settings.write("Size", Size);
	System.Gadget.Settings.write("Buttons", Buttons);
	System.Gadget.Settings.write("ButtonsSet", ButtonsSet);
	System.Gadget.Settings.write("Page", Page);
	System.Gadget.Settings.write("LockButton", LockButton);
	System.Gadget.Settings.write("LockPanel", LockPanel);
	System.Gadget.Settings.write("AmbientSet", AmbientSet);
	System.Gadget.Settings.write("UpdateSet", UpdateSet);
	System.Gadget.Settings.write("UpdateFlag", UpdateFlag);
	System.Gadget.Settings.write("ConfirmSet", ConfirmSet);
	
	RefreshUI();
}

function LoadXML(xmlFile) 
{ 
 XMLDoc.async="false"; 
 XMLDoc.onreadystatechange=Verify; 
 XMLDoc.load(xmlFile); 
 xmlObj=XMLDoc.documentElement; 
}

function Verify() 
{ 
 	if (XMLDoc.readyState != 4) 
		return false; 
}

//*************************************************************
//  Check Updates
//*************************************************************
function CheckUpdates()
{
	var Version = "1.2";

	if (UpdateSet == "On")
	{
		try 
		{
			LoadXML("http://www.buildagadget.com/Gadgets/Updates/SystemControl.xml");
			var xFile = XMLDoc.getElementsByTagName("SystemControl")[0];
			var NewVersion = xFile.getElementsByTagName("Version")[0].text;
			if (parseFloat(Version) < parseFloat(NewVersion))
				System.Gadget.Settings.write("UpdateFlag", "On");
			else
				System.Gadget.Settings.write("UpdateFlag", "Off");
			
			SaveData();
			RefreshUI();
		}
		catch(err){}
	}
	else
		UpdateFlag == "Off";
}

//*************************************************************
//  Toggle Update Flyout
//*************************************************************
function ToggleUpdateFlyout()
{
	if (System.Gadget.Flyout.show == false)
	{
		System.Gadget.Flyout.file = "Update.html";
		System.Gadget.Flyout.show = true;
	}
	else
		System.Gadget.Flyout.show = false;
}